#class auto
/*****************************************************
     The input and output buffers sizes are defined here. If these
     are not defined to be (2^n)-1, where n = 1...15, or they are
     not defined at all, they will default to 31 and a compiler
     warning will be displayed.
******************************************************/
#define BINBUFSIZE  15
#define BOUTBUFSIZE 15

// This timeout period determines when an active input data stream is
//   considered to have ended and is implemented within serBread.
#define MSSG_TMOUT 10000UL  // will discontinue collecting data 10 seconds after
                           // receiving any character or when maxSize are read.

// This timeout period determines when to give up waiting for any data to
//   arrive and must be implemented within the user's program, as it is below.
#define IDLE_TMOUT 30000UL // will timeout after 30 seconds if no data is read.


void main()
{
	unsigned long t;
	int n,i;
	unsigned char indata[32];
	static const char Fox[]="The quick brown fox jumps over the lazy dog 01234567890\n";


	WrPortI ( SPCR, &SPCRShadow, 0x84 );		// PA0-7 = Outputs
	n = 0;
   serBopen(300);
   for (;;) {
   	costate {				// Receive
   		t = MS_TIMER;
   		waitfordone {
         	n = cof_serBread(indata, sizeof(indata), MSSG_TMOUT); // yields until ends
         }
         if(n!=sizeof(indata))
	   			printf ("\nTimeout, %d characteres recibidos: %s\n", n,indata);
         else printf ("Rx: %s\n",indata);
      }
   	costate {				// Transmit
	   	waitfordone {
         	cof_serBwrite(Fox, sizeof(Fox));
         }
         BitWrPortI( PADR, &PADRShadow, (PADRShadow&2)^2, 1 ); // toggle LED 3
      }
      costate {				// Rx timeout
    		if (MS_TIMER > t + IDLE_TMOUT){
    			t = MS_TIMER;
    			printf("\nInactivo\n");
    		}
      }
      costate {				// Dummy
      	waitfor(DelayMs(250));
         BitWrPortI( PADR, &PADRShadow, (PADRShadow&1)^1, 0); // toggle LED 2
		}
   }

   while (serBwrFree() != BOUTBUFSIZE);	// wait for Tx buffer empty
   serBclose();									// disables B serial port r/w
}